package com.jdcity.jzt.bkuser.common.utils;

import java.util.Random;
import org.apache.commons.codec.digest.DigestUtils;

public final class PasswordUtils {

   public static String generateSaltPassword(String password) {
      Random random = new Random();
      StringBuilder buffer = new StringBuilder(16);
      buffer.append(random.nextInt(99999999)).append(random.nextInt(99999999));
      int length = buffer.length();
      if(length < 16) {
         for(int salt = 0; salt < 16 - length; ++salt) {
            buffer.append("0");
         }
      }

      String var8 = buffer.toString();
      password = DigestUtils.md5Hex(password + var8);
      char[] charArray = new char[48];

      for(int i = 0; i < 48; i += 3) {
         charArray[i] = password.charAt(i / 3 * 2);
         char c = var8.charAt(i / 3);
         charArray[i + 1] = c;
         charArray[i + 2] = password.charAt(i / 3 * 2 + 1);
      }

      return new String(charArray);
   }

   public static boolean verify(String password, String md5) {
      if(password != null && md5 != null && md5.length() == 48) {
         char[] passwordCharArray = new char[32];
         char[] saltCharArray = new char[16];

         for(int salt = 0; salt < 48; salt += 3) {
            passwordCharArray[salt / 3 * 2] = md5.charAt(salt);
            passwordCharArray[salt / 3 * 2 + 1] = md5.charAt(salt + 2);
            saltCharArray[salt / 3] = md5.charAt(salt + 1);
         }

         String salt1 = new String(saltCharArray);
         return DigestUtils.md5Hex(password + salt1).equals(new String(passwordCharArray));
      } else {
         return false;
      }
   }

   public static void main(String[] args) {
      System.out.println(generateSaltPassword("admin@renda"));
   }
}
